\chapter{To Conclude}
	\section{resume}
In order to check ZooKeeper, the model had to add a tracking action in order to face all kind of situations that combine synchronous and asynchronous actions. The model has to also add the state unknown, to know the existence of a node and if it is safe to check the data. this state is important because, between the time that the action is performed by the server and the time that the client receives the callback we have a delay. So beetween the call and the callback, the integrity of the data saves by the model is not guaranteed anymore.

This solution is possible because ZooKeeper is simple and allows just a few actions.
 So even by hand it is possible to think about each possibilities.

	\section{algorithm}
At the end the entire code that will test the service ZooKeeper can be build strictly just by following the table and the different step in the figure 5.1.
 
\begin{figure}[!h]
\centering
\includegraphics[scale=0.66]{image/ChapterConclusion/AlgoGeneral.pdf}
\caption{General progress of the algorithm}
\end{figure}

	\section{The code}
Here an example of the code that will follow the algorithm.
 With a writing action and a reading action, and each one with their call and their callback. 
 
		\subsection{writing action}
			\subsubsection{the call}
\begin{listing}[1]{1}

//Watch if any other operation is happening now
noPendingCreatePath = noPendingAction(choice, infoPendingCreate)
noPendingCreateParent = noPendingAction(mainPath, infoPendingCreate)
noPendingDeletePath = noPendingAction(choice, infoPendingDelete)
noPendingDeleteParent = noPendingAction(mainPath, infoPendingDelete)

//Add the pending items of this operation
addPendingInfo(choice, infoPendingCreate, infoCountCreate)
addPendingInfo(mainPath, infoPendingCreate, infoCountCreate)
addPendingInfo(mainPath, infoPendingCreateChildren, infoCountCreateChildren)
addPendingInfo(choice, infoPendingData, infoCountData)

//Watch the pending items that could change its outcome
countPendingCreatePath = infoCountCreate.getOrElse(choice, 0)
countPendingCreateParent = infoCountCreate.getOrElse(mainPath, 0)
countPendingDeletePath = infoCountDelete.getOrElse(choice, 0)
countPendingDeleteParent = infoCountDelete.getOrElse(mainPath, 0)

//Check if the path of the variables is known
parentKnown = isKnown(mainPath)
pathKnown = isKnown(choice)

//Save the variables to check during the callback
pathExists = verifExists(choice)
parentExists = verifExists(mainPath)
isEphemeral = isEphemeral(mainPath)
val nodeType = CreateMode.PERSISTENT

//Specific behaviour of this action = create the path needed
if(!(new File(verifPath + mainPath)).exists()) {
  (new File(verifPath + mainPath)).mkdirs()
  existenceUnknown += mainPath
  dataUnknown += mainPath
}
if(!(new File(verifPath + choice)).exists()) {
  (new File(verifPath + choice)).mkdirs()
  existenceUnknown += choice
  dataUnknown += choice
}

//Call of the action
zk.create(choice, null, ZooDefs.Ids.OPEN_ACL_UNSAFE, nodeType)
\end{listing}

			\subsubsection{the callback}
\begin{listingcont}
/**
The operation has succeeded. If we have no pending action,
the model confirm the existence of the node,
and add the node in the list of ephemeral node if it is in ephemeral mode.
Then the model confirm the existence of the node if there is not any pending action.
**/
		
//Specific behaviour of this operation
if (nodeType == CreateMode.EPHEMERAL) {
  listOfEphNodes += choice
  globalListZnodeEph += choice
}

//Check the variables previously saved
if(noPendingDeletePath && samePending(countPendingDeletePath, choice, infoCountDelete)) {
  //Confirm the existence/data of  the node
  if(pathKnown)
    assert(!pathExists)
  confirmCreate(choice)
}
if(noPendingCreateParent && samePending(countPendingCreateParent, mainPath, infoCountCreate)) {
  if(parentKnown)
    assert(parentExists)
}
if(noPendingDeleteParent && samePending(countPendingDeleteParent, mainPath, infoCountDelete)) {
  confirmCreate(mainPath)
}

//remove the pending items added by this operation
removePending(choice, infoPendingCreate)
removePending(mainPath, infoPendingCreate)
removePending(mainPath, infoPendingCreateChildren)
removePending(choice, infoPendingData)
\end{listingcont}


		\subsection{reading action}
			\subsubsection{the call}
\begin{listing}[1]{1}
//Check if the path of the variable is known
val isKnown = !existenceUnknown.contains(choice)
if(isKnown) {
		  
  //Watch if any other operation is happening now
  val noPendingCreatePathTemp = noPendingAction(choice, infoPendingCreate)
  val noPendingDeletePathTemp = noPendingAction(choice, infoPendingDelete)

  //Watch the pending items that could change its outcome
  val countPendingCreatePathTemp = infoCountCreate.getOrElse(choice, 0)
  val countPendingDeletePathTemp = infoCountDelete.getOrElse(choice, 0)

  //Save the variables to check during the callback
  val pathExistsTemp = verifExists(choice)
  val resExists = (zk.exists(choice, false) != null)
}
\end{listing}

			\subsubsection{the callback}
\begin{listingcont}
//Specific behaviour of this action in the callback
//None
			
//Check the variables previously saved
if(noPendingCreatePathTemp && samePending(countPendingCreatePathTemp, choice, infoCountCreate)
   && noPendingDeletePathTemp && samePending(countPendingDeletePathTemp, choice, infoCountDelete)) {
  assert(pathExistsTemp == resExists)
}
\end{listingcont}

	\section{Go further}
ZooKeeper has a lot of other options that are not shown in this report, so lots of work remain.
 For example :
 
		\subsection{More options}
\begin{itemize}
\item Implements the watchers (monitoring connection status)
\item Model other ZooKeeper features
\item Add multiple servers (quorum server)
\item Election of the main server (leader election)
\item Give different rights to the clients
\end{itemize}

		\subsection{Predict all the possible outcomes}
Moreover, the model can also be improved.
 The main idea was to predict all the possible outcomes,
 instead of avoiding to test the outcome each time that we have a pending action. 

The next two tables are an example of the possible outcomes for 3 actions performed simultaneously.
 We can see that some of these outcomes are unique. So if we have this kind of result,
 we could predict the result easily.
 
\begin{table}[h]
\centering
{\scriptsize
\input{image/ChapterConclusion/PredictOutcome.tex}
}
\end{table}

\begin{table}[h]
\centering
{\scriptsize
\input{image/ChapterConclusion/PredictOutcome2.tex}
}
\caption{All the possible outcomes for 3 actions}
\end{table}

	\section{Personal experience}
To conclude, this internship was a big opportunity for me to work in an institute of research,
 to work abroad, and to spend three months in order to use and learn new competences.
 It helps me to discover which points I must focus on, in order to improve my work.


If I had to do it again, I would. This internship was great in many ways.
 My coordinator in the enterprise followed me until the end of my internship,
 the enterprise and my co-workers help me in the life of every day,
 so even if I barely speak japanese, I was able to enjoy my stay in Japan.
 I discovered the japanese culture, the world of research in Japan.
 And finally, thanks to this internship, I have confirmed my choice for my future orientation.